\subsection{Reference Implementations}

\begin{frame}{Reference Implementations}
\begin{columns}
  \begin{column}{0.4\textwidth}
    \begin{itemize}
    \item Sequential version
    \item MPI
    \item CUDA
    \item Hadoop
    \end{itemize}
  \end{column}

  \begin{column}{0.25\textwidth}
    \includegraphics[width=0.8\textwidth]{mpi}
    \vspace{0.25\textheight}
    
    \includegraphics[width=0.8\textwidth]{hadoop}
  \end{column}
   
  \begin{column}{0.25\textwidth}
    \includegraphics[width=0.7\textwidth]{cuda}
  \end{column}
\end{columns}

\end{frame}

\subsection{Datasets}

\begin{frame}{Datasets}

\begin{block}{UCI Machine Learning Repository \cite{Lichman:2013}}

\begin{itemize}
	\item Clustering datasets
	\item Various numbers of instances
	\item Various numbers of attributes
	\item Real / Integer
\end{itemize}

\end{block}

\begin{columns}
\begin{column}{0.5\textwidth}

\textbf{Example:} Wholesale customers dataset, 440 instances, 8 attributes, integer.

Plot of three attributes.

\end{column}
\begin{column}{0.5\textwidth}

\begin{figure}
	\centering
	\includegraphics[scale=0.25]{dataset_wholesale}
\end{figure}

\end{column}
\end{columns}


\end{frame}

\subsection{Evaluation Metrics}

\begin{frame}{Evaluation Metrics}

\begin{block}{Quality: Root Mean Squared Error (RMSE)}

$C$: output of the algorithm \\
$\widehat{C}$: expected results

\[ \mathrm{MSE} = \frac{\sum\limits_{i=1}^k \left[ d(\widehat{c}_i, c_i) \right] ^2}{k}
\hspace*{2cm}
\mathrm{RMSE} = \sqrt{\mathrm{MSE}} \]

\end{block}

\vfill

\begin{footnotesize}

\textbf{Example with 3 clusters, in dimension 2}

\[
C_1 = \begin{pmatrix}
(1, 2) & (4, 8) & (5, 3)
\end{pmatrix}
\hspace*{1cm}
C_2 = \begin{pmatrix}
(1, 2) & (4, 8) & (4, 3)
\end{pmatrix}
\]
\[ \widehat{C} = \begin{pmatrix}
(1.3, 2.2) & (4.2,7.9) & (4.3, 3.2)
\end{pmatrix} \]

\[
RMSE_1 = \mathbf{0.49}
\hspace*{2cm}
RMSE_2 = \mathbf{0.32}
\]

\textbf{Conclusion:} $C_2$ is more accurate than $C_1$

\end{footnotesize}

\end{frame}


\begin{frame}{Evaluation Metrics}

\begin{block}{Runtime Improvement: \emph{SpeedUp}}

$RT_A$ (resp. $RT_B$): runtime of the algorithm A (resp. B) with the same dataset

\[ SpeedUp = \frac{RT_B}{RT_A} \]

\end{block}


\vfill

\begin{footnotesize}

\textbf{Example}

\begin{table}
	\centering
	\begin{tabular}{|c|c|}
		\hline
		& Runtime (ms) \\
		\hline
		Algorithm A & 12 \\
		\hline
		Algorithm B & 60 \\
		\hline
	\end{tabular}
\end{table}

\[ SpeedUp = 5 \]

\textbf{Conclusion:} Algorithm A is 5 times faster than algorithm B

\end{footnotesize}

\end{frame}



